# STM32H747I-EVAL Evaluation board

## Overview

The STM32H747I-EVAL Evaluation kit is a complete demonstration and development platform for Arm® Cortex®-M7 and Arm® Cortex®-M4 core-based STM32H747XI microcontroller, with 2 Mbyte of flash memory and  1 Mbyte of SRAM.

The STM32H747I-EVAL Evaluation kit is used as a reference design for user application development before porting to the final product, thus simplifying the application development.

The full range of hardware features available on the board helps users to enhance their application development by an evaluation of all the peripherals (such as USB OTG HS and USB OTG FS, Ethernet, USART, CAN FD, audio DAC and ADC, digital microphone, SRAM, SDRAM, NOR flash memory, twin Quad-SPI flash memory, microSD™ 3.0 card, RGB interface LCD with capacitive touch panel, and others). The expansion connectors provide an easy way to add specialized features, while ETM trace is supported through external probes.

STLINK-V3E is integrated into the board, as the embedded in-circuit debugger and programmer for the STM32 MCU and USB Virtual COM port bridge.

## Getting started

- [User manual](https://www.st.com/resource/en/user_manual/um2525-evaluation-boards-with-stm32h747xi-and-stm32h757xi-mcus-stmicroelectronics.pdf)

### ST-LINK driver installation and firmware upgrade (on Microsoft Windows)

1. Download the latest [ST-LINK driver](https://www.st.com/en/development-tools/stsw-link009.html).
2. Extract the archive and run `dpinst_amd64.exe`. Follow the displayed instructions.
3. Download the latest [ST-LINK firmware upgrade](https://www.st.com/en/development-tools/stsw-link007.html).
4. Extract the archive and run the `ST-LinkUpgrade.exe` program.
5. Connect the board to your PC using a USB cable and wait until the USB enumeration is completed.
6. In the **ST-Link Upgrade** program, press the **Device Connect** button.
7. When the ST-LINK driver is correctly installed, the current ST-LINK version is displayed.
8. Press the **Yes >>>>** button to start the firmware upgrade process.

## Technical reference

- [STM32H747XI microcontroller](https://www.st.com/en/microcontrollers-microprocessors/stm32h747xi.html)
- [STM32H747I-EVAL board](https://www.st.com/en/evaluation-tools/stm32h747i-eval.html)
- [User manual](https://www.st.com/resource/en/user_manual/um2525-evaluation-boards-with-stm32h747xi-and-stm32h757xi-mcus-stmicroelectronics.pdf)
- [Data brief](https://www.st.com/resource/en/data_brief/stm32h747i-eval.pdf)
- [Schematic](https://www.st.com/resource/en/schematic_pack/mb1246-b0x_schematic.pdf)
